declare const StreamingErrorType: {
    readonly BadSampleRate: 4000;
    readonly AuthFailed: 4001;
    readonly InsufficientFunds: 4002;
    readonly FreeTierUser: 4003;
    readonly NonexistentSessionId: 4004;
    readonly SessionExpired: 4008;
    readonly ClosedSession: 4010;
    readonly RateLimited: 4029;
    readonly UniqueSessionViolation: 4030;
    readonly SessionTimeout: 4031;
    readonly AudioTooShort: 4032;
    readonly AudioTooLong: 4033;
    readonly AudioTooSmallToTranscode: 4034;
    readonly BadSchema: 4101;
    readonly TooManyStreams: 4102;
    readonly Reconnected: 4103;
};
type StreamingErrorTypeCodes = (typeof StreamingErrorType)[keyof typeof StreamingErrorType];
declare const StreamingErrorMessages: Record<StreamingErrorTypeCodes, string>;
declare class StreamingError extends Error {
}
export { StreamingError, StreamingErrorType, StreamingErrorTypeCodes, StreamingErrorMessages, };
